#
# spec file for package diskscrub
# 
#
# Usage:
#   rpmbuild -ba ./diskscrub.spec
#

%define name  diskscrub

# specify location of RPM sources and build directory

%define home /home/olchansk
%define base /home/olchansk/sysadm/rpm

%define src        %{base}/%{name}

%define _rpmdir    %{base}/RPMS
%define _srcrpmdir %{base}/SRPMS
%define _builddir  %{base}/BUILD

Summary:      Scan disk for errors and trouble areas
Name:         %{name}
Version:      2
Release:      14
#Requires:     perl
#Copyright:    public domain
License:      public domain
Group:        XXX/XXX
#URL:          http://...
Packager:     Konstantin Olchanski <olchansk@triumf.ca>
BuildRoot:    %{_builddir}/%{name}
BuildArch:    noarch

%description
diskscrub scans disks for errors and trouble spots

%install
mkdir -p $RPM_BUILD_ROOT/usr/sbin/
mkdir -p $RPM_BUILD_ROOT/etc/cron.d
#g++ -o %{_topdir}/%{name}/diskscrub.exe -g -O2 -Wall -Wuninitialized %{_topdir}/%{name}/diskscrub.cc
rm %{src}/diskscrub.exe
touch %{src}/diskscrub.exe
cp %{src}/diskscrub.exe  $RPM_BUILD_ROOT/usr/sbin
cp %{src}/diskscrub.cc   $RPM_BUILD_ROOT/usr/sbin
cp %{src}/diskerase.cc   $RPM_BUILD_ROOT/usr/sbin
cp %{src}/diskscrub.cron $RPM_BUILD_ROOT/etc/cron.d

%clean
rm -rf %{name}

%files
%attr(755,root,root)         /usr/sbin/diskscrub.exe
%attr(644,root,root)         /usr/sbin/diskscrub.cc
%attr(644,root,root)         /usr/sbin/diskerase.cc
%attr(644,root,root) %config /etc/cron.d/diskscrub.cron

%post
rm -f /usr/sbin/diskscrub.exe
g++ -o /usr/sbin/diskscrub.exe -g -O2 -Wall -Wuninitialized /usr/sbin/diskscrub.cc
touch /etc/crontab

%changelog

* Wed Apr  4 2012 olchansk olchansk@triumf.ca
        Version 2-14
        add diskerase.cc
        improve email reports
        log error messages into summary log file
        bump slow read complaint from 10 sec to 20 sec

* Sun Jan 15 2012 olchansk olchansk@triumf.ca
        Version 2-13
        start scrubbing at 1am Monday, run for 4 days.
        compain about reads that take longer than 10 sec

* Thu Jan  5 2012 olchansk olchansk@triumf.ca
        Version 2-12
        start scrubbing at 10pm Monday, run for 4 days.

* Mon Dec 26 2011 olchansk olchansk@triumf.ca
        Version 2-11 (test)
        Rewrite:
        ionice
        slowdown to run on a weekly schedule
        send email from inside diskscrub (no need for diskscrub.perl)
        reorganised log files
        adjustable paramaters for slow reads, too slow reads, too many errors, etc

* Wed Dec 13 2006 olchansk olchansk@triumf.ca
        Version 1-10
        Fixes for Fedora 6

* Wed May  3 2006 olchansk olchansk@triumf.ca
        Version 1-9
        Some RHEL3 kernels fadvise() returns ENOTTY

* Tue Jan 10 2006 olchansk olchansk@triumf.ca
        Version 1-8
        Do not give up scanning after short timeouts
        Measure average disk read speed
        Use the total disk size to tell last EOF from a short read

* Wed Jul 20 2005 olchansk olchansk@triumf.ca
        Version 1-7
        Improve perl script: save reports into /var/log/diskscrub.txt,
        add "-v" switch, do not produce stdout output (no more
        emails from cron), email error reports to root.

* Tue Apr  5 2005 olchansk olchansk@triumf.ca
        Version 1-6
        Fix problem with missing fadvise() in RH8.0

* Thu Mar 31 2005 olchansk olchansk@triumf.ca
        Version 1-5
        Report slow reads only if they took more than 1 sec (was 0.5 sec)
        Add ability to rewrite slow areas (change doWrite=true, recompile)
        Improve disk detection in diskscrub.perl 
        Let diskscrub.perl take a list of disks as command line arguments

* Sun Feb 20 2005 olchansk olchansk@triumf.ca
        Version 1-4
        Only output progress indicator if isatty(stdin)

* Tue Feb 15 2005 olchansk olchansk@triumf.ca
        Version 1-3
        Fix paths for smartctl & co

* Thu Feb 10 2005 olchansk olchansk@triumf.ca
        Version 1-2
        Fix reporting bugs

* Sun Feb 06 2005 olchansk olchansk@triumf.ca
        Version 1-1
        First cut at the RPM file

#end file
